name 		= "BetterWalls"
version 	= "2.2.8"
description 	= "BetterWalls v"..version.."\nWalls health increased"
author 		= "Rincewind"
forumthread 	= "N/A"
api_version 	= 6
icon_atlas 	= "modicon.xml"
icon 		= "modicon.tex"
priority 	= -2

dont_starve_compatible 	= true
reign_of_giants_compatible = true
shipwrecked_compatible = true

------------------------------------------------------------------------------------------------------------------------

-- strings module emulation :/
local alpha 	= {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}
-- disabled for selection keys is 1, Alt-A|D|S|W is works, but also works as player mover, we dont need it. QE is disabled too.
local disabled 	= {"1","B","C","1","1","F","G","H","I","J","K","L","M","N","O","P","1","R","1","T","U","V","1","X","Y","Z"}
local numb 	= {"0","1","2","3","4","5","6","7","8","9"}
local KEY_A 	= 97

local function tostr(num)
	local s = ""
	local c = ""
	if num >= 10 then s = tostr(num/10) end
	num = num % 10
	for i = 10,1,-1 do
		if i > num then c = numb[i] else break end
	end
	return s .. c
end

local function GetKeyCode(char)
	if char == "Off" then return 0 end --lets save few nanoseconds from circle above
	for i = 2,#alpha do 
		if alpha[i]==char then return i + KEY_A - 2 end
	end
	return 0
end

local keyslist = {}
keyslist[1] = {description = "Off", data = "0"}
local j = 1
for i = 1,#alpha do 
	if disabled[i]~="1" then 
		j = j + 1
		keyslist[j] = {description=alpha[i], data=KEY_A+i-1} 
	end
end

local function WallMult(min,max,step)
	local a = {}
	local j = 0
	for i = min, max, step do
		j = j + 1
		a[j] = {description = "x"..tostr(i),data = i}
	end
	return a
end

------------------------------------------------------------------------------------------------------------------------


configuration_options =
{
    {
        name = "Wall label",
        options =
        {
            {description = "Enable", data = "on"},
            {description = "Disable", data = "off"}
        },
        default = "on",
    },
    {
        name = "Activate label on ALT+",
        options = keyslist,
        default = GetKeyCode("V"),
    },
    {
        name = "Hay wall",
        options = WallMult(1,5,1),
	default = 5
    },
    {
        name = "Wood wall",
        options = WallMult(1,7,1),
	default = 7
    },
    {
        name = "Stone wall",
        options = WallMult(1,10,1),
	default = 10
    },
    {
        name = "Limestone wall (SW)",
        options = WallMult(1,11,1),
	default = 11
    },
    {
        name = "Marble wall (MOD)",
        options = WallMult(1,12,1),
	default = 12
    },
    {
        name = "Nightmare wall (MOD)",
        options = WallMult(1,11,1),
	default = 11
    },
    {
        name = "Lava wall (MOD)",
        options = WallMult(1,13,1),
	default = 13
    },
    {
        name = "Ruins wall",
        options = WallMult(1,15,1),
	default = 15
    },
}
